<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Développement Android</title>
    <link rel="stylesheet" href="./styleDevPage.css">
    <link rel="stylesheet" href="../mainArticleStyle.css">
    <script src="../mainArticleScript.js"></script>
    <link rel="icon" type="image/svg" href="../img/cloud-snow.svg" />

</head>
<body>
    <header>
        <section class="headerContent">
            <span class="headerLink "><a href="../index.html"><img class="homeSvg" alt="Accueil" src="../img/home.svg"></a></span>
            <span class="headerLink"><a href="../umlPage/umlPage.html">Modélisation UML</a></span>
            <span class="headerLink "><a href="../ihmPage/imhPage.html">Interfaces utilisateur</a></span>
            <span class="headerLink active"><a href="../devPage/devPage.html">Développement Android</a></span>
        </section>
    </header>
    <main>
        <span class="touchBar"></span>
        
        <h1 class="pageTitle">Développement Android</h1>

        <div class="card fullWidth">
            <div class="cardHeader secondColor">Introduction : Android & IDE</div>
            <div class="cardContent">
                <p class="textContent">
                    C’est l’un des deux systèmes qui <b>dominent le marché mondial</b> du mobile avec <i>IOS</i>. En Europe, il va représenter <a href="https://www.presse-citron.net/android-perd-des-parts-de-marche-ios-en-hausse/">jusqu’à 70% du marché </a>. De plus en plus d’appareils mobiles fonctionnent sous Android: smartphones, tablettes, wearables devices comme montres intelligentes ou encore Smart TV. Le <b>langage de programmation Java </b>a été choisi par Google pour créer des applications Android. Il est donc assez clair que développer des applis android peut-être très <i>rentable</i>, cependant le développement Java sera <u>incontournable</u>.
                    C’est pourquoi il vous faudra un <u>IDE</u> (<u>Environnement de Développement Embarqué</u>) <b>performant et cohérent</b> avec les technologies que vous utilisez. Pour le développement Java il existe de nombreux IDE, c’est ce qu’il vous sera présenté ici.
                </p>
            </div>
        </div>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Qu’est-ce qu’un bon IDE ?</div>
                <div class="cardContent">
                    <p class="textContent">
                        L’IDE ou environnement de développement intégré est un logiciel qui regroupe l’ensemble des outils de base nécessaires à la <i>conception et aux tests d’applications.</i> Il permet de <b>coder plus rapidement</b> et plus facilement en automatisant une partie des processus et en simplifiant les opérations. Afin de choisir le vôtre il existe certains <b><u>critères essentiels</u></b> pour que ces plateformes soient les plus optimales possible :
                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <p>
                        <ul>
                            <li>
                                <p>
                                    <h3><u>La polyvalence :</u></h3> Un point crucial pour vous permettre de développer à l’aide de <b>différents langages et frameworks</b>. Dans notre cas, il n'a que <u>peu d’importance</u> puisque notre sujet représente une unique technologie : Android.
                                </p>
                            </li>
                            <li>
                                <p>
                                    <h3><u>La personnalisation : </u></h3>Dans le but d’améliorer votre <b>confort</b> et votre productivité il est primordial d’avoir un IDE qui vous ressemble et qui correspond à vos <b>habitudes</b>. La capacité à créer des raccourcis personnalisés, à changer le thème, régler l’autocomplétion,... Toutes ces choses qui rendront votre environnement de développement agréable.
                                </p>
                            </li>
                            <li>
                                <p>
                                    <h3><u>Capacités de débogage : </u></h3>Un dernier point très important à prendre en compte est la <b>possibilité de déboguer</b>. En effet, certains IDE sont très pratiques et vous permettent de <i>visualiser le contenu des variables en fonction du temps</i>, mais aussi de mettre des <i>points d’arrêt</i>, et même de modifier votre code lors de l’exécution pour quelques langages.
                                </p>
                            </li>
                        </ul>
                    </p>
                </div>
            </div>
        </section>


        <div class="card fullWidth">
            <div class="cardHeader secondColor">Les possibilités avec Android :</div>
            <div class="cardContent">
                <p class="textContent">
                   <div class="contentInline">
                        <img width="70" height="70"src="../img/logo_android_studio.png">
                        <p><b>Leader incontestable du marché</b>, <u>Android studio</u> est un outil de programmation populaire recommandé par Google. Il est livré avec des fonctionnalités de haut niveau pour faciliter le travail des développeurs dans le développement d'applications Android. L'une des fonctionnalités essentielles est ses périphériques virtuels (émulateurs). Ces émulateurs vont vous permettre de simuler les performances d’un téléphone précis et de tester votre code.</p>
                   </div>
                   <br>
                   <div class="contentInline">
                        <img width="70" height="70"src="../img/logo_eclipse.png">
                        <p><b>IDE de base pour le développement en JAVA</b> <u>Eclipse IDE</u> se présente comme une possibilité tout à fait convaincante. Introduit en 2001 en tant qu'outil de programmation Java, et depuis lors, il a évolué et est devenu l'IDE préféré des développeurs en raison de sa prise en charge de divers langages. Eclipse prend en charge Android avec l'extension Google ADT, est livré avec un outil de construction par défaut appelé ANT, et est livré avec une complétion de code automatique haut de gamme.</p>
                    </div>
                    <br>
                    <div class="contentInline">
                        <img width="70" height="70"src="../img/logo_visual_studio_code.png">
                    <p><u>Microsoft introduit Visual Studio</u> <b>principalement pour Windows, Linux et macOS</b>. Il vous permet de développer des applications mobiles et de bureau avec .NET MAUI. Il permet aux développeurs d'automatiser le cycle de vie de vos applications iOS, Android, Windows et macOS. Les développeurs peuvent tester sur des milliers d'appareils réels, distribuer aux bêta-testeurs et aux magasins d'applications, et surveiller l'utilisation dans le monde réel à l'aide de données d'analyse.</p>
                    </div>
                </p>
            </div>
        </div>

        <img class="displayImage" alt="Accueil" src="../img/utiliser_AndroidStudio.png">

        <div class="card fullWidth">
            <div class="cardHeader secondColor">Avantages et inconvénients d’Android Studio :</div>
            <div class="cardContent">
                <p class="textContent">
                    Même si de nombreuses possibilités existent, à l’heure actuelle, Android Studio est plus ou moins inévitable. Avant de vous engager avec dernier, voici un récapitulatif des avantages et inconvénients : <br><br>
                    <h3><u>Les avantages :</u></h3><br>
                    Android Studio permet d'avoir un IDE totalement dédié aux développements Android, pour d'autre type de développements JAVA il faut utiliser InteliJ IDE ou Eclipse.                 Cette restriction peut paraître contraignante mais elle permet de ne pas mélanger différents types de développements sur un meme IDE et donc évite la surcharge de l'IDE et les erreurs de compatibilités entre les différents types de développements.<br><br>
                    Android Studio dispose d'une interface intuitive et simple d'utilisation. Si vous êtes habitué à utiliser Eclipse vous n'aurez aucun mal à vous adapter à Android Studio et vous vous rendrez vite compte que le développement Android est facilité. <br><br>
                    Le fait de télécharger Android Studio évite aussi de télécharger un IDE puis de télécharger un SDK Android qu'on rajoute ensuite à notre IDE. Ici on a tout ce qu'il nous faut en téléchargeant uniquement Android Studio<br><br>
                    En conclusion, le téléchargement et l'utilisation d'Android Studio représente un gain de temps conséquent.<br><br>      
                    <h3><u>Inconvénient :</u></h3><br>
                    <h4>Lent</h4><br>
                    Le principal et quasiment l’unique inconvénient d’android studio est sa lenteur. Si vous n’avez pas une machine correcte, il risque de vous poser quelques soucis et ralentir votre développement. Notamment l'émulateur qui met énormément de temps à s'ouvrir et fera globalement ralentir votre ordinateur. Il est conseillé de l'utiliser uniquement si vous en avez vraiment besoin.<br><br>      
                    Pour résumer : utiliser un véritable appareil Android pour débugguer dans la grande majorité des cas. Lorsque vous n'avez pas le choix ou que vous souhaitez tester vos interfaces graphiques et que vous ne disposez pas de différents type d'appareil, utilisez l'émulateur.     
                </p>
            </div>
        </div>

        <button class="adviceButton" onclick="displayAdvice()"><img class="homeSvg" alt="Accueil" src="../img/info.svg"></button>

        <div class="card advice hidden" id="advice">
            <div class="cardHeader"><img onclick="hideAdvice()" class="windowAction close" alt="Accueil" src="../img/x-circle.svg">Astuce</div>
            <div class="cardContent">
                <p class="textContent">
                    Pour palier le problème de performances d'android studio (au niveau de son émulateur) il est possible de brancher votre téléphone sur votre pc et d'utiliser directement ce dernier.<br>
                    Cela aura pour impact de soulager votre processeur et de ne pas allouer de la ressource pour à l'émulation d'un os android complet
                </p>
            </div>
        </div>

    </main>
    <footer>
        <section class="footerContent">
            <h6>All right reserved | Copyright © 2022 CHAPUIS DEPRECQ</h6>
        </section>
    </footer>
</body>
</html>
